// Checks whether a character is a DBCS character or not
function isDBCSChar(unichar, isDBCSSession, isDBCSEuro, CodePage)
{
    if (!isDBCSSession) return false;
    if (useAccentedCharacters && ('\u0080' <= unichar) && (unichar <= '\u00FF')) return false;
    if (unichar == '\u20a9') return false;
    if (unichar == '\u20ac') {
        if (isDBCSEuro) return true;
        else return false;
    }
    if((unichar == '\u00a6') && (CodePage == 1390 || CodePage == 1399)) return true;    
    if ('\u0080' <= unichar && unichar <= '\u00A1'
        || '\u00A4' == unichar
        || '\u00A7' <= unichar && unichar <= '\u00AB'
        || '\u00AD' <= unichar && unichar <= '\u00AE'
        || '\u00B0' <= unichar && unichar <= '\u04FF'
        || '\u0600' <= unichar && unichar <= '\u06FF'
        || '\u0F00' <= unichar && unichar <= '\u0FFF'
        || '\u1100' <= unichar && unichar <= '\u11FF'
        || '\u1800' <= unichar && unichar <= '\u18FF'
        || '\u1E00' <= unichar && unichar <= '\u27BF'
        || '\u2E80' <= unichar && unichar <= '\u2EF3'
        || '\u2ff0' <= unichar && unichar <= '\u2ffb'
        || '\u3000' <= unichar && unichar <= '\u33FF'
        || '\u3400' <= unichar && unichar <= '\u4DFF'
        || '\u4E00' <= unichar && unichar <= '\u9FA5'
        || '\uA000' <= unichar && unichar <= '\uA4FF'
        || '\uAC00' <= unichar && unichar <= '\uD7A3'
        || '\uE000' <= unichar && unichar <= '\uF86F'
        || '\uF900' <= unichar && unichar <= '\uFB4F'
        || '\uFB50' <= unichar && unichar <= '\uFDFF'
        || '\uFE20' <= unichar && unichar <= '\uFE6F'
        || '\uFE70' <= unichar && unichar <= '\uFEFF'
        || '\uFF00' <= unichar && unichar <= '\uFF5F'
        || '\uFFE0' <= unichar && unichar <= '\uFFE6'
        || '\uFFF0' <= unichar && unichar <= '\uFFFF') return true;

    return false;
}

function allowDBCSOnly3270(event) {
    allowGField(event);
}

function allowDBCSPure(event) {
    allowGField(event);
}

// Allows only DBCS character event
function allowGField(event)
{
    event = (event) ? event : ((window.event) ? window.event : "");
    var code = event.keyCode ? event.keyCode : event.which;

    if(enableAutoConvertSBCStoDBCS && isIE && event.type == "keypress") {
        if(code == 32) {
            event.keyCode = 0x3000;
            event.returnValue = true;
        } else if(code >= 33 && code <=126) {
            event.keyCode = 65281 + (code - 33);
            event.returnValue = true;
            return;
        }
    }
    
    var ck = function(code) {
        if (isDBCSChar(String.fromCharCode(code), enableDBCSSession, enableDBCSEuro, CodePage)) return true;
        return false;
    };
    contentCheck(event, ck);
}

function allowDBCSOnly5250(event) {
    allowJField(event);
}

// Allows only DBCS character event
function allowJField(event)
{
    if(showUnProtectedSosiAsSpace && event.type != "keypress") { //$for event other than keypress and show SOSI is on$//     
        event = (event) ? event : ((window.event) ? window.event : "");
	    var code = event.keyCode ? event.keyCode : event.which;
	    
	    //$Verify the text character by character with the "ck" function$//
        var verifyText = function(inStr, ck) {
            var outStr = "";
            for (var i=0; i< inStr.length; i++)
            {
              if (ck(inStr.charCodeAt(i))) outStr += inStr.charAt(i);
              else break;
              //else continue;
            }
            return outStr;
        };
        
        //$function to remove any SBCS spaces in string$//
        var removeSpaces = function(inStr) {
          var outStr = "";
          for (var i=0; i< inStr.length; i++) {
            if (inStr.charCodeAt(i) != 32) outStr += inStr.charAt(i);
          }
          return outStr;
        };
        
        var ck = function(code) {
            if (isDBCSChar(String.fromCharCode(code), enableDBCSSession, enableDBCSEuro, CodePage)) return true;
            return false;
        };

        if(event.type == "paste" || event.type == "drop") { //$Check the pasted/drop text is valid or not. The cursor position will be after last character after paste/drop$//
            //$This is a Win IE only featurre$//
            if (!isIE || MAC) return;
            //$Find the caret position in the input field, the cPos varaible is what we need$//
            var caretPos = document.selection.createRange().duplicate();
            var selectText = document.selection.createRange().text; 
            var t = caretPos.parentElement();
            var beginField = t.createTextRange();
            caretPos.collapse();
            beginField.collapse();
            var slen = t.value.length;
            var cPos = 0;
            for (; cPos <= slen ; cPos++ ) {
                qa =caretPos.getBoundingClientRect();
                qb = beginField.getBoundingClientRect();
                if ( qa.left == qb.left ) break;
                caretPos.move("character",-1);
            } 
            //$remove SO/SI and adjust cursor position$//
            if(t.value.length > 0) {
                if(t.value.charCodeAt(0) == 32) { //$remove Shift-out$//
                    if(cPos > 0) cPos--;
                    t.value = t.value.substring(1, t.value.length);
                }
                if(t.value.charCodeAt(t.value.length-1) == 32) { //$remove Shift-in$//
                    if(cPos > t.value.length-1) cPos--;
                    t.value = t.value.substring(0, t.value.length-1);
                }
            }
            slen = t.value.length;

            //$verify text to be pasted/dropped$//
            var pText = "";
            if(event.type == "paste") pText = verifyText(removeSpaces(clipboardData.getData("Text")),ck);
            else if (event.type == "drop") pText = verifyText(removeSpaces(event.dataTransfer.getData("Text")),ck);
            //$Overrride default paste behaivor with above algorithm$//
            if(pText.length > 0 && selectText == "") {
                if(isOverWriteMode()) {
                    //$If overwrite mode enabled, overwrite current content with clipboard text and trim to field max length$//
                    if(cPos + pText.length > slen) {
                        t.value = t.value.substring(0,cPos) + pText;
                    } else { 
                        t.value = t.value.substring(0,cPos) + pText + t.value.substring(cPos + pText.length ,slen);
                    }
                } else {
                    //$If insert mode enabled, insert proper legth of text in clip board$//
                    t.value = t.value.substring(0,cPos) + pText.substring(0, t.maxLength - 2 - slen) + t.value.substring(cPos,slen);
                }
            }
            else if(pText.length > 0 && selectText != ""){
                 t.value = t.value.substring(0,cPos) + pText + t.value.substring(cPos + selectText.length ,slen);
            }   
            //$restore SO. Trim to proper length.  Restore SI if reach maxLength for auto advance$//
            t.value = " " + t.value;
            if(t.value.length > t.maxLength - 2) {
                t.value = t.value.substring(0, t.maxLength - 1) + " ";
            }
            event.returnValue = false;
            return;
        } else if(enableDBCSSession && ((event.type == "keydown" && (code == 13 || code == 19 || code == 27 || code == 33 || code == 34 || (code > 111 && code < 124))) //$check keydown for submit, include ENTER and PF keys$//
                                         || (event.type == "keyup" && code == 13)  //$check keyup for ENTER, this is for L2 IME submit action$//
                                         || event.type == "click" || event.type == "blur")) { //$Check the text in the field is valid for click and blur$//

            var t = (isIE) ? event.srcElement : event.target;
            
            var nText = removeSpaces(t.value); //$trim SBCS spaces in original text$//
            nText = verifyText(nText,ck); //$content check, remove invalid text$//
            if(nText.length > t.maxLength - 2) { //$trim text too long, the DBCS count can only be maxLength -2$//
                nText = nText.substring(0, t.maxLength - 2); 
            }
            
            var isValid = false; //$check need to replace text in the field or not$//
            if(nText == t.value) isValid = true; //$If original text is identical to processed one, no modification$//

            nText = " " + nText;
            if(nText == t.value) isValid = true; //$If original text is identical to processed one, no modification$//

            if(nText.length == t.maxLength - 1) { //$reach text max length, trigger auto advance$//
              nText = nText + " "; 
              if(nText == t.value) isValid = true;
            }

            if(!isValid) {
                t.value = nText;
	            if(isIE) {
	                event.returnValue = false;
	            } else {
	                event.returnValue = false; //$Although there is no returnValue in mozilla, we add this attribute and set it to false to stop submit action$//
	        	    event.preventDefault();
	            }
            }
	    }
    } else { //$for keypress event, means try to insert SBCS to J-field. Or for show SOSI off, apply G field algorithm$//  
       allowGField(event);
    }
}

function allowAlphaNumericShift(event) {
	var ck = function(code) {
        if (isDBCSChar(String.fromCharCode(code), enableDBCSSession, enableDBCSEuro, CodePage)) return false;
		return true;
    };
    contentCheck(event, ck);
}

function allowKatakanaShift(event) {
    allowAlphaNumericShift(event);
}

// Allows only SBCS character event
function allowSBCSOnly(event) {}


function allowDBCSEither(event) {
    event = (event) ? event : ((window.event) ? window.event : "");
	var code = event.keyCode ? event.keyCode : event.which;
    var element = (isIE) ? event.srcElement : event.target;
    var isJFieldMode = element.getAttribute("jFieldMode");

    var ck = function (firstCharCode, element) { //$adjust length and execute content checking accroding to content$//
        if(isDBCSChar(String.fromCharCode(firstCharCode), enableDBCSSession, enableDBCSEuro, CodePage)) {
            if(showUnProtectedSosiAsSpace) {
                element.maxLength = element.size /2 + 1;
            } else {
                element.maxLength = element.size /2 - 1;
            }
            element.style.imeMode = "active";
            allowJField(event);
            element.setAttribute("currentJFieldMode", "true");
        } else {
            element.maxLength = element.size;
            element.style.imeMode = "inactive";
            allowAlphaNumericShift(event);
            element.setAttribute("currentJFieldMode", "false");
        }
        return;        
    };


    if(isJFieldMode == "true") { //$host field is with DBCS characters, always J field mode$//
        element.setAttribute("currentJFieldMode", "true");
        allowJField(event);
        return;
    } 
    
    if(element.value.length > 0 && !(element.value.length == 1 && showUnProtectedSosiAsSpace && element.value.charCodeAt(0) == 32)) { //$host field is not empty, switch to AlphaNumericShift or J-field mode depends on first character$//
        var firstCharCode = element.value.charCodeAt(0);
        if(showUnProtectedSosiAsSpace && firstCharCode == 32 && element.value.length > 1) {
            firstCharCode = element.value.charCodeAt(1);
        }
        ck(firstCharCode, element);
    } else if(event.type == "paste" || event.type == "drop") { //$host field is empty and user paste data, check the data pasted$//
        var pText = "";
        if(event.type == "paste") pText = clipboardData.getData("Text");
        if(event.type == "drop") pText = event.dataTransfer.getData("Text");
        if(pText.length > 0) {
            var firstCharCode = pText.charCodeAt(0);
            if(showUnProtectedSosiAsSpace && firstCharCode == 32 && pText.length > 1) {
                firstCharCode = pText.charCodeAt(1);
            }
            ck(firstCharCode, element);
        }
    }
}
function addPseudoSOSI(pseudoSO, pseudoSI, objValue) {
    var modifiedValue = "";
    var inputValue = new String(objValue);
    var inputValueLength = inputValue.length;
    if (inputValue != null) {
       for (var j=0; j<inputValueLength; j++) {
       	    var currentString = inputValue.substr(j,1);
            var nextCurrentString = inputValue.substr(j+1,1);
            if (parseInt(j+1) >= inputValueLength)
                nextCurrentString = null;
            // case 1 : if first character is DBCS, add pseudoSO
       	    if (isDBCSChar(currentString, enableDBCSSession, enableDBCSEuro, CodePage)) {
       	       if (j == 0)
                   modifiedValue = modifiedValue + "" + pseudoSO + "" + currentString;
               if (parseInt(j+1) == inputValueLength) {
               	   if (j == 0)
               	      currentString = "";
                   modifiedValue = modifiedValue + "" + currentString;                   
               }
               if (j >=0 && parseInt(j+1) != inputValueLength) {
               	   if (nextCurrentString != null && !isDBCSChar(nextCurrentString, enableDBCSSession, enableDBCSEuro, CodePage)) {
               	       if (j == 0)
               	          currentString = "";
                       modifiedValue = modifiedValue + "" + currentString + pseudoSI;
               	   } else {
               	       if (j == 0)
               	           currentString = "";
                       modifiedValue = modifiedValue + "" + currentString;
                   }
               }
       	    } else {
                 if (nextCurrentString != null && isDBCSChar(nextCurrentString, enableDBCSSession, enableDBCSEuro, CodePage)) {
                     modifiedValue = modifiedValue + "" + currentString + "" + pseudoSO;
                 } else {
                     modifiedValue = modifiedValue + "" + currentString;
                 }
       	    }
        }
    }
    return modifiedValue;
}
function countDataLength(pseudoSO, pseudoSI, inputValue) {
    //pseudoSO, pseudoSI and SBCS have length 1
    //only DBCS has length 2
    var stringLength = 0;
    for (var i=0; i < inputValue.length; i++) {
    	var currentString = inputValue.substr(i,1);
    	if (currentString == pseudoSO || currentString == pseudoSI) {
    	    stringLength++;
        } else {
            if (isDBCSChar(currentString, enableDBCSSession, enableDBCSEuro, CodePage)) {
                stringLength = stringLength + 2;
            } else {
                stringLength++;
            }
        }
    }
    return stringLength;
}
function dataLengthChecking(pseudoSO, pseudoSI, inputValue, obj) {
    var iname = obj.name;
    var pool = iname.split("_");
    var inputSize = parseInt(pool[2]);
    var modifiedValue = inputValue;
    if (countDataLength(pseudoSO, pseudoSI, modifiedValue) > inputSize) {
    	var isWithinInputSize = false;
    	var isAlmostWithinInputSize = false;
    	var i = modifiedValue.length - 1;
        while(isWithinInputSize == false && i > -1) {
            //remove pseudoSO and pseudoSI, if there is no DBCS within pseudoSO and pseudoSI
            if (isAlmostWithinInputSize == true) {
                if(modifiedValue.substr(modifiedValue.length-1,1) == pseudoSI &&
                    modifiedValue.substr(modifiedValue.length-2,1) == pseudoSO) {
                    modifiedValue = modifiedValue.substr(0,modifiedValue.length -2);
                }
                isWithinInputSize = true;
                break;
            }
            modifiedValue = inputValue.substr(0, i);
            //add pseudoSI, if the last character is DBCS or pseudoSO
            if (isDBCSChar(modifiedValue.substr(modifiedValue.length-1,1), enableDBCSSession, enableDBCSEuro, CodePage) ||
                modifiedValue.substr(modifiedValue.length-1,1) == pseudoSO) {
                modifiedValue = modifiedValue + "" + pseudoSI;
            }
            if (countDataLength(pseudoSO, pseudoSI, modifiedValue) <= inputSize) {
                isAlmostWithinInputSize = true;
            }
            i--;
        }
    }
    return modifiedValue;
}
function replacePseudoSOSI(pseudoSO, pseudoSI, inputValue) {
    var startPositionSO = inputValue.indexOf(pseudoSO);
    var startPositionSI = inputValue.indexOf(pseudoSI);
    var replaceString = "";
    if (showUnProtectedSosiAsSpace) {
        replaceString = " ";
    }
    while (startPositionSO != -1 || startPositionSI != -1) {
        inputValue = inputValue.replace(pseudoSO, replaceString);   	
        inputValue = inputValue.replace(pseudoSI, replaceString);   	
        startPositionSO = inputValue.indexOf(pseudoSO);
        startPositionSI = inputValue.indexOf(pseudoSI);
    }
    return inputValue;
}
function removeSpaceAsSOSI(modifiedValue) {
    var modifiedValue = modifiedValue;
    var temp = "";
    var modeSBCS = "SBCS";
    var modeDBCS = "DBCS";
    //mode character only SBCS or DBCS
    var modeCharacter = modeSBCS;
    var concatNextString = true;
    for (var i=0; i<modifiedValue.length;i++) {
    	if (concatNextString == false) {
  	    concatNextString = true;
    	    continue;
        }
    	var currentString = modifiedValue.substr(i,1);
    	var nextCurrentString = modifiedValue.substr(i+1,1);
    	var doubleNextCurrentString = modifiedValue.substr(i+2,1);
    	var tripleNextCurrentString = modifiedValue.substr(i+3,1);
        var concatString = true;
    	if (parseInt(i+1) >= modifiedValue.length)
            nextCurrentString = null;
    	if (parseInt(i+2) >= modifiedValue.length)
            doubleNextCurrentString = null;
    	if (parseInt(i+3) >= modifiedValue.length)
            tripleNextCurrentString = null;

    	if (isDBCSChar(currentString, enableDBCSSession, enableDBCSEuro, CodePage))
    	    modeCharacter = modeDBCS;
        else
    	    modeCharacter = modeSBCS;
        if (currentString == " " && modeCharacter == modeSBCS) {
            if (nextCurrentString != null && isDBCSChar(nextCurrentString, enableDBCSSession, enableDBCSEuro, CodePage))
                concatString = false;
        }
        if (modeCharacter == modeDBCS && nextCurrentString == " " &&  doubleNextCurrentString == null) {
            concatNextString = false;
        } else if (modeCharacter == modeDBCS && nextCurrentString == " " &&
            doubleNextCurrentString != null && doubleNextCurrentString != " " && !isDBCSChar(doubleNextCurrentString, enableDBCSSession, enableDBCSEuro, CodePage)) {
            concatNextString = false;
        } else if (modeCharacter == modeDBCS && nextCurrentString == " " &&
            doubleNextCurrentString != null && isDBCSChar(doubleNextCurrentString, enableDBCSSession, enableDBCSEuro, CodePage)) {
            currentString = currentString + " ";
            i++;
        } else if (modeCharacter == modeDBCS && nextCurrentString == " " &&
            doubleNextCurrentString == " " && tripleNextCurrentString != null &&
            isDBCSChar(tripleNextCurrentString, enableDBCSSession, enableDBCSEuro, CodePage)) {
            currentString = currentString + "  ";
            i = i + 2;
        } else if (modeCharacter == modeDBCS && nextCurrentString == " " &&
            doubleNextCurrentString == " " && tripleNextCurrentString != null &&
            tripleNextCurrentString != " " &&
            !isDBCSChar(tripleNextCurrentString, enableDBCSSession, enableDBCSEuro, CodePage)) {
            currentString = currentString + " ";
            i = i + 2;
        } else if (modeCharacter == modeDBCS && nextCurrentString == " " &&
            doubleNextCurrentString == " " && tripleNextCurrentString == " ") {
            currentString = currentString + " ";
            i = i + 2;
        }
        if (concatString)
            temp = temp.concat(currentString);
    }
    return temp;
}

function getCurrentPosition() {
    var caretPos = document.selection.createRange().duplicate();
    t = caretPos.parentElement();
    if (t.type!="text" && t.type!="password" && t.type!="textarea") return -1;
    var beginField = t.createTextRange();
    caretPos.collapse();
    beginField.collapse();
    var slen = t.value.length ;
    for ( pos = 0 ; pos <= slen ; pos++ )
    {
      qa =caretPos.getBoundingClientRect();
      qb = beginField.getBoundingClientRect();
      if ( qa.left == qb.left )
      {
        break;
      }
      caretPos.move("character",-1);
    }
    return pos;
}
function setCurrentPosition(cursorPosition) {
    var caretPos = document.selection.createRange();
    for ( pos = 0 ; pos < cursorPosition ; pos++ )
    {
      caretPos.move("character",1);
    }
    caretPos.select();
}
function allowDataLengthCheckingAlgorithm(event) {
    var pseudoSO = '\u001F';
    var pseudoSI = '\u001E';
    var obj = (isIE) ? event.srcElement : event.target;
    var modifiedValue = obj.value;
    var tempModifiedValue = obj.value;
    if(isIE){
        var cursorPosition = getCurrentPosition();
        //if (event.type == "paste") {
        //    var pasteValue = clipboardData.getData("Text");
        if (event.type == "paste" || event.type == "drop") {
            var pasteValue = "";
            if (event.type == "paste")
                pasteValue = clipboardData.getData("Text");
            if (event.type == "drop")
                pasteValue = event.dataTransfer.getData("Text");
            var beginString = "";
            var endString = "";
            if (parseInt(cursorPosition) > 0 && modifiedValue.length > 0) {
                beginString = modifiedValue.substr(0, cursorPosition);
            }
            if (overwritemodeenabled) {
                var endStringLength = parseInt(modifiedValue.length - cursorPosition + pasteValue.length);
                if (parseInt(endStringLength) >= 0) {
                    endString = modifiedValue.substr(parseInt(cursorPosition + pasteValue.length), endStringLength);
                }
            } else {
                endString = modifiedValue.substr(parseInt(cursorPosition), modifiedValue.length - cursorPosition);
            }
            if (pasteValue != null && pasteValue != "") {
                modifiedValue = beginString + "" + pasteValue + "" + endString;
            }
            if(isIE) {
	              event.returnValue = false;
	          } else {
                event.preventDefault();
	          }
        }
    }
    if (showUnProtectedSosiAsSpace) {
        modifiedValue = removeSpaceAsSOSI(modifiedValue);
    }
    modifiedValue = addPseudoSOSI(pseudoSO, pseudoSI, modifiedValue);
    modifiedValue = dataLengthChecking(pseudoSO, pseudoSI, modifiedValue, obj);
    modifiedValue = replacePseudoSOSI(pseudoSO, pseudoSI, modifiedValue);
    if (tempModifiedValue != modifiedValue) {
        obj.value = modifiedValue;
//        setCurrentPosition(cursorPosition);
    }
}
function allowDataLengthChecking(event) {
    var code = event.keyCode ? event.keyCode : event.which;
                                                           //enter      pause/break    escape         page up       page down       F1-F12
    if(enableDBCSSession && ((event.type == "keydown" && (code == 13 || code == 19 || code == 27 || code == 33 || code == 34 || (code > 111 && code < 124)))
                                         || (event.type == "keyup" && code == 13)
                                         || event.type == "paste" || event.type == "click" || event.type == "blur" || event.type == "drop")) {
        allowDataLengthCheckingAlgorithm(event);
    //} else if (event.type == "keypress" || event.type == "paste" || event.type == "blur" || event.type == "click" || event.type == "drop") {
    } else if (code == 13 || event.type == "paste" || event.type == "blur" || event.type == "click" || event.type == "drop") {    	
        allowDataLengthCheckingAlgorithm(event);
    }
}
