// This object sets a cookie containing Daylight Savings Time
// information in the session, to be retrieved on submit. This
// allows more accurate date calculations.
HxG_4.prototype.DSTCookie=function(nam) {
	this.CookieName = nam;

	// Calculate the start & end of DST
	HxG_4.prototype.DSTCookie.getDSTStartEnd=function(YYYY) {
		var jan, janOffset, JAN, JANOffset, Jul, JulOffset, Mar, Oct, JUL, T, J;
		
		with (new Date(YYYY, 0, 1)) { // 1-Jan-YYYY
			// Current settings
			jan = getTime();
			janOffset = getTimezoneOffset();
			
			// Check offset for July
			setMonth(06);
			Jul = JUL = getTime();
			JulOffset = getTimezoneOffset();

			// January
			setMonth(12);
			JAN = getTime();
			JANOffset = getTimezoneOffset();
			
			if (janOffset == JulOffset) { // Same: no DST
				return [];
			}
			
			Mar = jan;
			Oct = JAN;
			for (J=0; J<21; J++) {
				setTime(Mar) ; T=Mar;
				if (getTimezoneOffset() != janOffset) {
					Mar=(jan + Mar)/2 ; Jul=T;
				} else {
					Mar=(Mar + Jul)/2 ; jan=T;
				}
				setTime(Oct) ; T=Oct;
				if (getTimezoneOffset() != JulOffset) {
					Oct=(JUL + Oct)/2 ; JAN=T;
				} else {
					Oct=(Oct + JAN)/2 ; JUl=T;
				}
			}
			Mar=Math.round(Mar/60000)*60000
			Oct=Math.round(Oct/60000)*60000;
		}
		return [Mar, Oct];
	}
	
	// Generate the cookie contents and set it in the session
	HxG_4.prototype.DSTCookie.CreateCookie=function() {
		var currentYear = new Date().getFullYear();
		var jan = new Date(currentYear,0,1).getTimezoneOffset();
		var jul = new Date(currentYear,6,1).getTimezoneOffset();
		var tabDates = this.getDSTStartEnd(currentYear);
		var result = jan + " " + jul;
		
		if (tabDates[0]!=null && tabDates[1]!=null) {
			// Start date
			var dateMar = new Date();
			dateMar.setTime(tabDates[0]);
			var timeMar = dateMar.getHours()*3600000  +  dateMar.getMinutes()*60000;

			// End date
			var dateOct = new Date();
			dateOct.setTime(tabDates[1]);
			var timeOct = dateOct.getHours()*3600000  +  dateOct.getMinutes()*60000;
			
			result  +=" " + dateMar.getMonth() + " " + dateMar.getDate() + " " + dateMar.getDay() + " " + timeMar;
			result  +=" " + dateOct.getMonth() + " " + dateOct.getDate() + " " + dateOct.getDay() + " " + timeOct;
		}
		document.cookie = this.CookieName  +  "="  +  result  +  "; path=/";
	}
}
